﻿(*
  .dproj の <VerInfo_Keys> の記述を修正する

 Ver1.01 2023/07/20 フォーム高を可変にした
 Ver1.00 2019/08/05

*)

unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, StrUtils,
  Xml.XMLDoc, Xml.XMLIntf, System.IOUtils, Vcl.ExtCtrls, MultiMon,
  ShellAPI, Vcl.ComCtrls, Vcl.Mask;

type
  TFormMain = class(TForm)
    OpenDialog1: TOpenDialog;
    ButtonUpdate: TButton;
    LabeledEditFileName: TLabeledEdit;
    ButtonOpen: TButton;
    ButtonExit: TButton;
    ListView1: TListView;
    ButtonBaseOnly: TButton;
    Label1: TLabel;
    GroupBox1: TGroupBox;
    LabeledEditFileVer: TLabeledEdit;
    LabeledEditProductVer: TLabeledEdit;
    LabeledEditCopyright: TLabeledEdit;
    LabeledEditCompanyName: TLabeledEdit;
    LabeledEditInternalName: TLabeledEdit;
    LabeledEditLegalTrademarks: TLabeledEdit;
    LabeledEditOriginalFilename: TLabeledEdit;
    LabeledEditFileDescription: TLabeledEdit;
    LabeledEditProductName: TLabeledEdit;
    LabeledEditComments: TLabeledEdit;
    LabeledEditProgramID: TLabeledEdit;
    procedure ButtonUpdateClick(Sender: TObject);
    procedure ButtonOpenClick(Sender: TObject);
    procedure ButtonExitClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure OpenDialog1Show(Sender: TObject);
    procedure OpenDialog1Close(Sender: TObject);
    procedure ButtonBaseOnlyClick(Sender: TObject);
    procedure LabeledEditFileNameKeyPress(Sender: TObject; var Key: Char);
    procedure FormResize(Sender: TObject);
  private
    { Private 宣言 }
    FOpenDialog1hWnd: HWND;
    FNewOpenDialog1WndProc, FOldOpenDialog1WndProc: TFarProc;
    FOpenDialog1MoveFlag: Byte;
    procedure OpenDialog1WndProc(var Message: TMessage);
    Procedure WMDropFiles(Var Msg : TMessage); Message WM_DROPFILES;   // for Drag&Drop
  public
    { Public 宣言 }
  end;

var
  FormMain: TFormMain;


implementation

{$R *.dfm}


Var
  DecSep : String;  // 小数点記号 .,/


  // フォームTargetを表示しているモニタの座標とサイズを返す（Uses に MultiMon が必要）
  {
    TMonitorInfoEx = Record
      cbSize : Cardinal;  // レコードのサイズ
      rcMonitor : TRect;  // モニタの矩形
      rcWork : TRect;     // ワークエリアの矩形
      dwFlags : Cardinal; // プライマリモニタなら<>0
      szDevice : array[0..31] of Char; // デバイス名（NULL終端）
    end;
  }
  Function GetMonitorRect(Target : TForm = Nil) : TRect;
  Var LMonitorInfoEx : TMonitorInfoEx;
  begin
    FillChar(LMonitorInfoEx, SizeOf(TMonitorInfoEx), #0);
    LMonitorInfoEx.cbSize := SizeOf(LMonitorInfoEx);
    if Target=Nil then Target := Application.MainForm;
    GetMonitorInfo(Target.Monitor.Handle, @LMonitorInfoEx);
    Result := LMonitorInfoEx.rcWork;     // 有効エリアを返す
//  Result := LMonitorInfoEx.rcMonitor;  // フルエリアを返す場合
  end;


  //----------------------------- for FormMain.OpenDialog1 -----------------------------------------

  // OpenDialog1 OnShowイベント
  procedure TFormMain.OpenDialog1Show(Sender: TObject);
  begin
    if ofOldStyleDialog in (Sender as TOpenDialog).Options then
      FOpenDialog1hWnd := (Sender as TOpenDialog).Handle
    else
      FOpenDialog1hWnd := GetParent((Sender as TOpenDialog).Handle);
    // 動的サブクラス化
    FOpenDialog1MoveFlag := 3; // 位置調整していない
    FNewOpenDialog1WndProc := MakeObjectInstance(OpenDialog1WndProc);
    FOldOpenDialog1WndProc := Pointer(GetWindowLong(FOpenDialog1hWnd, GWL_WNDPROC));
    SetWindowLong(FOpenDialog1hWnd, GWL_WNDPROC, Int64(FNewOpenDialog1WndProc));
  end;

  // OpenDialog1 OnCloseイベント
  procedure TFormMain.OpenDialog1Close(Sender: TObject);
  begin
    // 動的サブクラス化を解除する
    SetWindowLong(FOpenDialog1hWnd, GWL_WNDPROC, INT64(FOldOpenDialog1WndProc));
    FreeObjectInstance(FNewOpenDialog1WndProc);
    FOpenDialog1hWnd       := HWND(nil);
    FNewOpenDialog1WndProc := nil;
    FOldOpenDialog1WndProc := nil;
  end;

  // OpenDialog1の新しいウィンドウプロシージャ
  procedure TFormMain.OpenDialog1WndProc(var Message: TMessage);
  var
    pWinPos: PWindowPos;
    ScreenRect, mc, rc: TRect;
  begin
    if (Message.Msg = WM_WINDOWPOSCHANGING) and (FOpenDialog1MoveFlag > 0) then begin
      pWinPos := PWindowPos(Message.LParam);
      pWinPos^.flags := pWinPos^.flags and not(SWP_NOMOVE);
      Dec(FOpenDialog1MoveFlag);
      // 表示位置をスクリーン座標で設定する
      ScreenRect := GetMonitorRect(FormMain);
      GetWindowRect(FormMain.Handle, mc);
      GetWindowRect(FOpenDialog1hWnd, rc);
      pWinPos^.x := mc.left + (mc.Width  - rc.Width)  div 2;
      pWinPos^.y := mc.Top  + (mc.Height - rc.Height) div 2;
      // スクリーンからはみ出さないように制限する
      if pWinPos^.y<ScreenRect.Top then pWinPos^.y := ScreenRect.Top;
      if pWinPos^.y>(ScreenRect.Bottom-rc.Height) then pWinPos^.y := ScreenRect.Bottom-rc.Height;
      if pWinPos^.x<ScreenRect.Left then pWinPos^.x := ScreenRect.Left;
      if pWinPos^.x>(ScreenRect.Right-rc.Width) then pWinPos^.x := ScreenRect.Right-rc.Width;
    end;
    Message.Result := CallWindowProc(FOldOpenDialog1WndProc, FOpenDialog1hWnd, Message.Msg, Message.WParam, Message.LParam);
  end;

  //-------------------------------------------------------------------


// ファイルをバックアップする  SetVer.dproj -> SetVer.dproj.mmdd
procedure Backup(Fn : String);
Var NewFn : String;
begin
  NewFn := Fn + '.bak';
  try
    if Not FileExists(NewFn) or
      (Now > (TFile.GetLastWriteTime(NewFn)+1.0))
    then begin
      TFile.Copy(Fn, NewFn, True);            // バックアップコピーを作成する
      TFile.SetLastWriteTime(NewFn, Now());   // ファイルの最終書き込み時刻を変更する
    end;
  except
    ;
  end;
end;


// バージョン表示のゼロサプレスを行う
function ZeroSup(St :String) : String;
var n, m : Integer;

  function Sup(St : String) : String;
  var n : integer;
  begin
    Try
      n := StrToInt(St);
    except
      n := 0;
    End;
    Result := IntToStr(n);
  end;

begin
  if Pos(DecSep, St)>0 then begin
    m := Pos(DecSep, St); if m=0 then m := Length(St)+1;
    n := 1;
    Result := Sup(Copy(St, n, m-1))+DecSep;
    n :=m;
    m := Pos(DecSep, St, n+1); if m=0 then m := Length(St)+1;
    Result := Result + Sup(Copy(St, n+1, m-n-1))+DecSep;
    n :=m;
    m := Pos(DecSep, St, n+1); if m=0 then m := Length(St)+1;
    Result := Result + Sup(Copy(St, n+1, m-n-1))+DecSep;
    n :=m;
    m := Pos(DecSep, St, n+1); if m=0 then m := Length(St)+1;
    Result := Result + Sup(Copy(St, n+1, m-n-1));
  end
  else
    Result := St;
end;


// バージョンを数値として大小比較を可能にする 1.2.34.0 -> .0001.0002.0034.0000....
Function ExpDig(St : String) : String;
Const Dig = 4;
Var n, m, i, it, Pern, Comn, Slan : Integer;
begin
  if Length(St)>=3 then begin
    Pern := 0; Comn := 0; Slan := 0;
    for n := 1 to Length(St) do begin
      if St[n]='.' then Inc(Pern);
      if St[n]=',' then Inc(Comn);
      if St[n]='/' then Inc(Slan);
    end;
    DecSep := '.';
    if (Comn>Pern) and (Comn>Slan) then DecSep := ','
    else if (Slan>Pern) and (Slan>Comn) then DecSep := '/';
  end;

  St := DecSep+St+StringOfChar(DecSep[1], 4);
  i := 1;
  for it := 1 to 4 do begin
    n := Pos(DecSep, St, i);
    m := Pos(DecSep, St, n+1);
    if (m-n)<=Dig then Insert(StringOfChar('0', Dig-(m-n)+1), St, n+1);
    i := m;
  end;
  Result := St;
end;


// 項目値を取り出す
Function PicupVer(St, Key : String; Var KeyVal : String) : String;
Var n, m : Integer;
begin
  Result := '';
  n := Pos(Key, St);
  if n>0 then begin
    m := Pos(';', St, n);
    if m=0 then m := Length(St)+1;
    if m>0 then begin
      Result := Copy(St, n, m-n);
      n := Pos('=', Result);
      St := Copy(Result, n+1, 50);
      if Pos('FileVersion=', Key)<>Pos('ProductVersion=', Key) then begin
        if ExpDig(St)>ExpDig(KeyVal) then KeyVal := St;
      end
      else
        if St<>'' then KeyVal := St;
    end;
    n := pos('=', Result);
    Delete(Result, 1, n);
  end;
end;


// 設定値を表示する
// Flg が True なら Edit Version に最大値を表示する
procedure Check(Flg : Boolean);
var
  FileName: string; //XMLファイルのファイル名
  XMLDocument: IXMLDocument;
  Pmode : String;
  Fv, Pv, Cp, FVerMax, PVerMax, CopMax, CPs,
  Comt, Comp, IntN, LTra, OrgF, Desc, Pnam, PrID,
  Comts, Comps, IntNs, LTras, OrgFs, Descs, Pnams, PrIDs : string;
  ii, jj : Integer;

  procedure DispNode(XMLNode: IXMLNode);
  const
    NodeName: string = 'VerInfo_Keys'; // 検索するノードの名前
  var
    I: Integer; St : String;
  begin
    With FormMain do begin
      Case XMLNode.NodeType of
       ntElement	: Try
                      if XMLNode.ParentNode.Attributes['Condition']<>Null then
                        PMode := XMLNode.ParentNode.Attributes['Condition'];
                    except
                      ;
                    end;
       ntText	:  if (XMLNode.ParentNode.NodeName = NodeName) then begin
                   St :=  XMLNode.NodeValue;
                   Fv := PicupVer(St, 'FileVersion=', FVerMax);
                   Pv := PicupVer(St, 'ProductVersion=', PVerMax);
                   Cp := PicupVer(St, 'LegalCopyright=', CPs);
                   Comt := PicupVer(St, 'Comments=', Comts);
                   Comp := PicupVer(St, 'CompanyName=', Comps);
                   IntN := PicupVer(St, 'InternalName=', IntNs);
                   LTra := PicupVer(St, 'LegalTrademarks=', LTras);
                   OrgF := PicupVer(St, 'OriginalFilename=', OrgFs);
                   Desc := PicupVer(St, 'FileDescription=', Descs);
                   Pnam := PicupVer(St, 'ProductName=', Pnams);
                   PrID := PicupVer(St, 'ProgramID=', PrIDs);
                   i := -1;
                   if (Pmode = '''$(Base_Win32)''!=''''')  then i := 0;
                   if (Pmode = '''$(Base_Win64)''!=''''')  then i := 1;
                   if (Pmode = '''$(Cfg_1_Win32)''!=''''') then i := 2;
                   if (Pmode = '''$(Cfg_2_Win32)''!=''''') then i := 3;
                   if (Pmode = '''$(Cfg_1_Win64)''!=''''') then i := 4;
                   if (Pmode = '''$(Cfg_2_Win64)''!=''''') then i := 5;
                   if i>=0 then begin
                     ListView1.Items[0].SubItems[i] := Comp;
                     ListView1.Items[1].SubItems[i] := Desc;
                     ListView1.Items[2].SubItems[i] := FV;
                     ListView1.Items[3].SubItems[i] := IntN;
                     ListView1.Items[4].SubItems[i] := Cp;
                     ListView1.Items[5].SubItems[i] := LTra;
                     ListView1.Items[6].SubItems[i] := OrgF;
                     ListView1.Items[7].SubItems[i] := PrID;
                     ListView1.Items[8].SubItems[i] := Pnam;
                     ListView1.Items[9].SubItems[i] := Pv;
                    ListView1.Items[10].SubItems[i] := Comt;
                   end;
                 end;
      end;
      for I := 0 to XMLNode.ChildNodes.Count - 1 do begin
        DispNode(XMLNode.ChildNodes.Nodes[I]);
      end;
    end;
  end;

begin
  with FormMain do begin
    FVerMax := '';  PVerMax := ''; CopMax := ''; CPS := '';
    Comps := ''; IntNs := ''; LTras := ''; OrgFs := ''; Comts := '';
    if flg then begin
      LabeledEditFileVer.text := '';  LabeledEditProductVer.text := ''; LabeledEditCopyright.text := '';
      LabeledEditCompanyName.Text := ''; LabeledEditInternalName.Text := ''; LabeledEditLegalTrademarks.Text := '';
      LabeledEditOriginalFilename.Text := ''; LabeledEditComments.Text := '';
    end;
    for ii := 0 to ListView1.Items.Count-1 do
      for jj := 0 to ListView1.Columns.Count-2 do
        ListView1.Items[ii].SubItems[jj] := '';
    FileName := Trim(LabeledEditFileName.Text);
    if (FileName<>'') and FileExists(FileName) then begin
      try
        XMLDocument := LoadXMLDocument(FileName);
        DispNode(XMLDocument.DocumentElement);
        if Flg then begin
          LabeledEditFileVer.Text         := FVerMax;
          LabeledEditProductVer.Text      := PVerMax;
          LabeledEditCopyright.Text       := CPs;
          LabeledEditCompanyName.Text     := Comps;
          LabeledEditInternalName.Text    := IntNs;
          LabeledEditLegalTrademarks.Text := LTras;
          LabeledEditOriginalFilename.Text:= OrgFs;
          LabeledEditFileDescription.Text := Descs;
          LabeledEditProductName.Text     := Pnams;
          LabeledEditProgramID.Text       := PrIDs;
          LabeledEditComments.Text        := Comts;
          if  LabeledEditFileVer.Text  ='' then LabeledEditFileVer.Text := LabeledEditProductVer.Text;
          if LabeledEditProductVer.Text='' then LabeledEditProductVer.Text := LabeledEditFileVer.Text;
        end;
      except
        LabeledEditFileName.Text := '';
      end;
    end;
  end;
end;

//------------------------------------------------


// 更新実行
procedure TFormMain.ButtonUpdateClick(Sender: TObject);
var
  FileName: string; //XMLファイルのファイル名
  XMLDocument: IXMLDocument;

  // 設定を更新する
  procedure ChangeNode(XMLNode: IXMLNode);
  const
    NodeName: string = 'VerInfo_Keys'; // 検索するノードの名前
  var
    I: Integer;

    procedure ChangeVer(VerName, NewVer : String);
    Var n, m : Integer; St : String;
    begin
      n := Pos(VerName+'=', XMLNode.NodeValue);
      if n>0 then begin
        m := Pos(';', XMLNode.NodeValue, n);
        if m=0 then m := Length(XMLNode.NodeValue)+1;
        if m>0 then begin
          St := Copy(XMLNode.NodeValue, n, m-n);
          XMLNode.NodeValue := ReplaceText(XMLNode.NodeValue, St, VerName+'='+NewVer);
        end;
      end;
    end;

  begin
    With FormMain do begin
      if (XMLNode.NodeType = ntText) then begin
        if (XMLNode.ParentNode.NodeName = NodeName) then begin
          ChangeVer('FileVersion',     Trim(LabeledEditFileVer.text));
          ChangeVer('ProductVersion',  Trim(LabeledEditProductVer.text));
          ChangeVer('LegalCopyright',  Trim(LabeledEditCopyright.text));
          ChangeVer('CompanyName',     Trim(LabeledEditCompanyName.text));
          ChangeVer('InternalName',    Trim(LabeledEditInternalName.text));
          ChangeVer('LegalTrademarks', Trim(LabeledEditLegalTrademarks.text));
          ChangeVer('OriginalFilename',Trim(LabeledEditOriginalFilename.text));
          ChangeVer('FileDescription', Trim(LabeledEditFileDescription.text));
          ChangeVer('ProductName',     Trim(LabeledEditProductName.text));
          ChangeVer('ProgramID',       Trim(LabeledEditProgramID.text));
          ChangeVer('Comments',        Trim(LabeledEditComments.text));
        end;
      end;
      for I := 0 to XMLNode.ChildNodes.Count - 1 do begin
        ChangeNode(XMLNode.ChildNodes.Nodes[I]);
      end;
    end;
  end;

begin
  LabeledEditFileVer.text := ZeroSup(LabeledEditFileVer.text);
  LabeledEditProductVer.text := ZeroSup(LabeledEditProductVer.text);
  FileName := Trim(LabeledEditFileName.Text);
  if (FileName<>'') and FileExists(FileName) then begin
    Backup(FileName);
    XMLDocument := LoadXMLDocument(FileName);
    ChangeNode(XMLDocument.DocumentElement);
    XMLDocument.SaveToFile(FileName);
  end;
  Check(False);
end;


//---------------------------------------------------
// 個別のDebug とReleaseのバージョン設定を削除する
procedure TFormMain.ButtonBaseOnlyClick(Sender: TObject);
var
  FileName: string; //XMLファイルのファイル名
  XMLDocument: IXMLDocument;
  Pmode, B32s, B64s : String;
  B32, B64 : Boolean;

  // Win32, Win64 の Release と Debug エントリーを削除する
  procedure DelNode(XMLNode: IXMLNode);
  const
    NodeName: string = 'VerInfo_Keys'; // 検索するノードの名前
  var
    I: Integer;

    Function ChangeVer(Dt : String) : String;

      function ChangeVerS(Dt, VerName, NewVer : String) : String;
      Var n, m : Integer; St : String;
      begin
        Result := Dt;
        n := Pos(VerName+'=', Dt);
        if n>0 then begin
          m := Pos(';', Dt, n);
          if m=0 then m := Pos('<', Dt, n);
          if m>0 then begin
            St := Copy(Dt, n, m-n);
            Result := ReplaceText(Dt, St, VerName+'='+NewVer);
          end;
        end;
      end;

    Begin
      if Trim(LabeledEditFileVer.Text)<>''    then Dt := ChangeVerS(Dt, 'FileVersion',    LabeledEditFileVer.Text);
      if Trim(LabeledEditProductVer.Text)<>'' then Dt := ChangeVerS(Dt, 'ProductVersion', LabeledEditProductVer.Text);
      Result := Dt;
    End;

  begin
    With FormMain do begin
      Case XMLNode.NodeType of
       ntElement	: Try
                      if XMLNode.ParentNode.Attributes['Condition']<>Null then
                        PMode := XMLNode.ParentNode.Attributes['Condition'];
                    except
                      ;
                    end;
       ntText	:  if (XMLNode.ParentNode.NodeName = NodeName) then begin
                   if (Pmode = '''$(Cfg_1_Win32)''!=''''') or (Pmode = '''$(Cfg_1_Win64)''!=''''') or
                      (Pmode = '''$(Cfg_2_Win32)''!=''''') or (Pmode = '''$(Cfg_2_Win64)''!=''''') then
                   begin
                     if (Pmode = '''$(Cfg_1_Win32)''!=''''') then B32s := ChangeVer(XMLNode.NodeValue);
                     if (Pmode = '''$(Cfg_1_Win64)''!=''''') then B64s := ChangeVer(XMLNode.NodeValue);
                     XMLNode.NodeValue := '';
                     Pmode := '';
                   end
                   else begin
                     if (Pmode = '''$(Base_Win32)''!=''''') then B32 := False;
                     if (Pmode = '''$(Base_Win64)''!=''''') then B64 := False;
                   end;
                 end;
      end;
      for I := 0 to XMLNode.ChildNodes.Count - 1 do begin
        DelNode(XMLNode.ChildNodes.Nodes[I]);
      end;
    end;
  end;

  // Win32Base と Win54Base に VerInfo_Keys がない場合は追加する
  procedure PushNode(XMLNode: IXMLNode);
  var
    I: Integer;
    ValueNode : IXMLNode;
  begin
    With FormMain do begin
      Case XMLNode.NodeType of
       ntElement	: begin
                      Try
                        if XMLNode.ParentNode.Attributes['Condition']<>Null then
                          PMode := XMLNode.ParentNode.Attributes['Condition'];
                      except
                        ;
                      end;
                      if B32 and (Pmode = '''$(Base_Win32)''!=''''') then begin
                        B32 := False;
                        XMLNode := XMLNode.ParentNode;
                        ValueNode := XMLNode.AddChild('VerInfo_Keys');
                        ValueNode.Text := B32s;
                      end;
                      if B64 and (Pmode = '''$(Base_Win64)''!=''''') then begin
                        B64 := False;
                        XMLNode := XMLNode.ParentNode;
                        ValueNode := XMLNode.AddChild('VerInfo_Keys');
                        ValueNode.Text := B64s;
                      end;
                    end;
      end;
      for I := 0 to XMLNode.ChildNodes.Count - 1 do begin
        PushNode(XMLNode.ChildNodes.Nodes[I]);
      end;
    end;
  end;

begin
  B32 := True; B64 := True;
  B32s := ''; B64s := '';
  FileName := Trim(LabeledEditFileName.Text);
  if (FileName<>'') and FileExists(FileName) then begin
    BackUp(FileName);
    XMLDocument := LoadXMLDocument(FileName);
    DelNode(XMLDocument.DocumentElement);
    PushNode(XMLDocument.DocumentElement);
    XMLDocument.SaveToFile(FileName);
  end;
  ButtonUpdateClick(Self);
end;


// OpeDialogを開いてファイルを選択する
procedure TFormMain.ButtonOpenClick(Sender: TObject);
begin
  if OpenDialog1.Execute then begin
    LabeledEditFileName.Text := OpenDialog1.FileName;
    Check(True);
  end;
end;


// 実行中のファイルのバージョン情報を取り出す
function GetFxeVersion : String;
var
  aVersion : Cardinal;
  St : String;
begin
  aVersion := GetFileVersion(Application.ExeName);  //ファイルのバージョンを取得
  St := IntTostr(aVersion and $FFFF);
  while Length(St)<2 do St := '0' + St;
  Result := IntToStr(aVersion shr 16) +DecSep+ St;
end;


// Form Createイベント
procedure TFormMain.FormCreate(Sender: TObject);
Const
  Items : array[0..10] of String = ('CompanyName', 'FileDescription', 'FileVersion', 'InternalName', 'LegalCopyright',
                                   'LegalTrademarks', 'OriginalFilename', 'ProgramID', 'ProductName', 'ProductVersion', 'Comments');
Var
  n : Integer;
  ListItem: TListItem;
begin
  DragAcceptFiles(Handle, True);  // for Drag&Drop
  DecSep := '.';
  Caption := 'Set .dproj version  Ver'+ GetFxeVersion;
  {$IFDEF DEBUG} Caption := Caption + ' *** Debug mode ***'; {$ENDIF}
  for n := 0 to Length(Items)-1 do begin
    ListItem := ListView1.Items.Add;
    ListItem.Caption := Items[n];
    ListItem.SubItems.Add('');
    ListItem.SubItems.Add('');
    ListItem.SubItems.Add('');
    ListItem.SubItems.Add('');
    ListItem.SubItems.Add('');
    ListItem.SubItems.Add('');
    ListItem.SubItems.Add('');
    ListItem.SubItems.Add('');
  end;
  // Hint表示を設定する
  if GetUserDefaultLCID <> $411 then begin // 日本語以外
    LabeledEditFileName.Hint := 'Enter the file name with the full path and press the "Enter" key';
    ButtonOpen.Hint     := 'Launch an Open dialog';
    ButtonBaseOnly.Hint := 'Update "Win32Base" and"Win64Base" and delete other settings';
    ButtonUpdate.Hint   := 'Update the setting with the value of "Data for setting"';
    ButtonExit.Hint     := 'Terminate';
  end
  else begin
    LabeledEditFileName.Hint := 'ファイル名をフルパスで入力して「Enter」キーを押す';
    ButtonOpen.Hint     := 'オープンダイアログを起動する';
    ButtonBaseOnly.Hint := '「Win32Base」と「Win64Base」を更新し、その他の設定を削除する';
    ButtonUpdate.Hint   := '「Data for setting」の値で設定を更新する';
    ButtonExit.Hint     := '終了する';
  end;
end;


procedure TFormMain.FormResize(Sender: TObject);
begin
  ListView1.Height := FormMain.ClientHeight-ListView1.Top -15;
  ButtonExit.Top := FormMain.ClientHeight-ButtonExit.Height -15;
end;

procedure TFormMain.LabeledEditFileNameKeyPress(Sender: TObject; var Key: Char);
begin
  if Key=^M then begin
    Key := #0;
    if Trim(LabeledEditFileName.Text)<>'' then Check(True);
  end;
end;


// Drag&Drop
Procedure TFormMain.WMDropFiles(Var Msg : TMessage);
Const BuffSize = 255;
Var FileName : Array[0..Buffsize] of Char;
  n, i : integer;
  Fn : String;
Begin
  Try
    n := DragQueryFile(Msg.wParam, $FFFFFFFF, Nil, BuffSize); // ドラッグファイル数を取り出す
    For i := 0 To n-1 Do begin
      DragQueryFile(Msg.wParam, i, FileName, BuffSize);
      Fn := String(FileName); // ドラッグされたファイル名を取り出す
      // Fn に対する処理
      LabeledEditFileName.Text := Fn;
    End;
    Msg.Result := 0;
    if Trim(LabeledEditFileName.Text)<>'' then Check(True);
  Finally
    DragFinish(Msg.wParam);
  End;
End;


// 終了
procedure TFormMain.ButtonExitClick(Sender: TObject);
begin
  Close;
end;


end.
